package com.sun.xml.internal.ws.model;

import java.security.AccessController;
import java.security.PrivilegedAction;
import java.net.URL;
import java.lang.reflect.InvocationTargetException;
import javax.xml.ws.WebServiceException;
import java.util.logging.Level;
import java.lang.reflect.Method;
import java.util.logging.Logger;

final class Injector
{
    private static final Logger LOGGER;
    private static final Method defineClass;
    private static final Method resolveClass;
    private static final Method getPackage;
    private static final Method definePackage;
    
    Injector() {
    }
    
    static synchronized Class inject(ClassLoader cl, String className, byte[] image) {
        try {
            return cl.loadClass(className);
        }
        catch (ClassNotFoundException ex) {
            try {
                int packIndex = className.lastIndexOf(46);
                if (packIndex != -1) {
                    String pkgname = className.substring(0, packIndex);
                    Package pkg = (Package)Injector.getPackage.invoke(cl, new Object[] { pkgname });
                    if (pkg == null) {
                        Injector.definePackage.invoke(cl, new Object[] { pkgname, null, null, null, null, null, null, null });
                    }
                }
                Class<Object> c = (Class)Injector.defineClass.invoke(cl, new Object[] { className.replace('/', '.'), image, Integer.valueOf(0), Integer.valueOf(image.length) });
                Injector.resolveClass.invoke(cl, new Object[] { c });
                return c;
            }
            catch (IllegalAccessException e) {
                Injector.LOGGER.log(Level.FINE, "Unable to inject " + className, e);
                throw new WebServiceException(e);
            }
            catch (InvocationTargetException e2) {
                Injector.LOGGER.log(Level.FINE, "Unable to inject " + className, e2);
                throw new WebServiceException(e2);
            }
        }
    }
    
    static {
        LOGGER = Logger.getLogger(Injector.class.getName());
        try {
            defineClass = ClassLoader.class.getDeclaredMethod("defineClass", new Class[] { String.class, byte[].class, Integer.TYPE, Integer.TYPE });
            resolveClass = ClassLoader.class.getDeclaredMethod("resolveClass", new Class[] { Class.class });
            getPackage = ClassLoader.class.getDeclaredMethod("getPackage", new Class[] { String.class });
            definePackage = ClassLoader.class.getDeclaredMethod("definePackage", new Class[] { String.class, String.class, String.class, String.class, String.class, String.class, String.class, URL.class });
        }
        catch (NoSuchMethodException e) {
            throw new NoSuchMethodError(e.getMessage());
        }
        AccessController.doPrivileged(new PrivilegedAction<Void>() {
            @Override
            public Void run() {
                Injector.defineClass.setAccessible(true);
                Injector.resolveClass.setAccessible(true);
                Injector.getPackage.setAccessible(true);
                Injector.definePackage.setAccessible(true);
                return null;
            }
        });
    }
}
